#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <map>

#include <Corrade/Containers/StringView.h>

#include <Magnum/Types.h>

using namespace Corrade;
using namespace Containers::Literals;
using namespace Magnum;

struct ArmourSet {
    Containers::StringView name;
    bool neck_compatible;
};

static const std::map<Int, ArmourSet> armour_sets {
    {-1, {"<unequipped>"_s,      true}},
    {0,  {"Vanguard"_s,          true}},
    {1,  {"Assault Mk.I"_s,      true}},
    {2,  {"Assault Mk.II"_s,     false}},
    {3,  {"Assault Mk.III"_s,    false}},
    {7,  {"Titan 001"_s,         true}},
    {8,  {"Titan 002"_s,         false}},
    {9,  {"Titan 003"_s,         false}},
    {13, {"Blitz X"_s,           true}},
    {14, {"Blitz EX"_s,          false}},
    {15, {"Blitz EXS"_s,         false}},
    {16, {"Kaiser S-R0"_s,       true}},
    {17, {"Kaiser S-R1"_s,       false}},
    {18, {"Kaiser S-R2"_s,       false}},
    {19, {"Hammerfall MG-A"_s,   true}},
    {20, {"Hammerfall MG-S"_s,   false}},
    {21, {"Hammerfall MG-X"_s,   false}},
    {22, {"Panzer S-UC"_s,       true}},
    {23, {"Panzer L-UC"_s,       false}},
    {24, {"Panzer H-UC"_s,       false}},
    {25, {"Axial Core R-Type"_s, true}},
    {26, {"Axial Core S-Type"_s, false}},
    {27, {"Axial Core X-Type"_s, false}},
};
