#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <map>

#include <Corrade/Containers/StringView.h>

#include <Magnum/Types.h>

using namespace Corrade;
using namespace Containers::Literals;
using namespace Magnum;

static const std::map<Int, Containers::StringView> mission_id_map {{
    // Story missions
    {0x0064, "Mission 1 - Training"_s},
    {0x0065, "Mission 2 - Patrol Operation"_s},
    {0x0066, "Mission 3 - Fusion Cells in the Snow"_s},
    {0x0067, "Mission 4 - Earning Changes"_s},
    {0x0068, "Mission 5 - Unexpected Coordination"_s},
    {0x0069, "Mission 6 - Empowering Void"_s},
    {0x006A, "Mission 7 - Logisitics Obstacles"_s},
    {0x006B, "Mission 8 - Wrath of the Wastelands"_s},
    {0x006C, "Mission 9 - Suspicious Originator"_s},
    {0x006D, "Mission 10 - Researchers Data Recovery"_s},
    {0x006E, "Mission 11 - Tempestuous Sector"_s},
    {0x006F, "Mission 12 - Clashes of Metal"_s},
    {0x0070, "Mission 13 - The Sandstorm Glutton"_s},
    {0x0071, "Mission 14 - An Icy Investigation"_s},
    {0x0072, "Mission 15 - Outposts Line of Defense"_s},

    // Hunting grounds
    {0x00C8, "Hunt 1 - Desert Pathway Safety"_s},
    {0x00C9, "Hunt 2 - Snowfield Custodian"_s},
    {0x00CA, "Hunt 3 - Abandoned Valley Raid"_s},
    {0x00CB, "Hunt 4 - Depths of the Machineries"_s},
    {0x00CC, "Hunt 5 - Crater Crashers"_s},

    // Challenges
    {0x012C, "Challenge 1 - Redline Battlefront"_s},
    {0x0140, "Challenge 2 - Void Convergence"_s},
    {0x0190, "Challenge 3 - Gates of Ascension"_s}
}};
