#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <map>

#include <Corrade/Containers/StringView.h>

#include <Magnum/Magnum.h>

using namespace Corrade;
using namespace Containers::Literals;
using namespace Magnum;

extern const std::map<Int, Containers::StringView> style_names
#ifdef STYLENAMES_DEFINITION
{
    {0,  "Custom Style 1"_s},
    {1,  "Custom Style 2"_s},
    {2,  "Custom Style 3"_s},
    {3,  "Custom Style 4"_s},
    {4,  "Custom Style 5"_s},
    {5,  "Custom Style 6"_s},
    {6,  "Custom Style 7"_s},
    {7,  "Custom Style 8"_s},
    {8,  "Custom Style 9"_s},
    {9,  "Custom Style 10"_s},
    {10, "Custom Style 11"_s},
    {11, "Custom Style 12"_s},
    {12, "Custom Style 13"_s},
    {13, "Custom Style 14"_s},
    {14, "Custom Style 15"_s},
    {15, "Custom Style 16"_s},

    {50, "Global Style 1"_s},
    {51, "Global Style 2"_s},
    {52, "Global Style 3"_s},
    {53, "Global Style 4"_s},
    {54, "Global Style 5"_s},
    {55, "Global Style 6"_s},
    {56, "Global Style 7"_s},
    {57, "Global Style 8"_s},
    {58, "Global Style 9"_s},
    {59, "Global Style 10"_s},
    {60, "Global Style 11"_s},
    {61, "Global Style 12"_s},
    {62, "Global Style 13"_s},
    {63, "Global Style 14"_s},
    {64, "Global Style 15"_s},
    {65, "Global Style 16"_s},

    {100, "Iron"_s},
    {101, "Silver"_s},
    {102, "Gold"_s},
    {103, "Bronze"_s},
    {104, "Copper"_s},
    {105, "Nickel"_s},
    {106, "Cobalt"_s},
    {107, "Aluminium"_s},
    {108, "Titanium"_s},
    {109, "Platinum"_s},
    {110, "Gun Metal"_s},
    {111, "White"_s},
    {112, "White Metal"_s},
    {113, "White Gloss"_s},
    {114, "Grey"_s},
    {115, "Grey Metal"_s},
    {116, "Grey Gloss"_s},
    {117, "Dark Grey"_s},
    {118, "Dark Grey Metal"_s},
    {119, "Dark Grey Gloss"_s},
    {120, "Black"_s},
    {121, "Black Metal"_s},
    {122, "Black Gloss"_s},
    {123, "Red"_s},
    {124, "Red Metal"_s},
    {125, "Red Gloss"_s},
    {126, "Dark Red"_s},
    {127, "Dark Red Metal"_s},
    {128, "Dark Red Gloss"_s},
    {129, "Orange"_s},
    {130, "Orange Metal"_s},
    {131, "Orange Gloss"_s},
    {132, "Dark Orange"_s},
    {133, "Dark Orange Metal"_s},
    {134, "Dark Orange Gloss"_s},
    {135, "Yellow"_s},
    {136, "Yellow Metal"_s},
    {137, "Yellow Gloss"_s},
    {138, "Brown"_s},
    {139, "Brown Metal"_s},
    {140, "Brown Gloss"_s},
    {141, "Dark Brown"_s},
    {142, "Dark Brown Metal"_s},
    {143, "Dark Brown Gloss"_s},
    {144, "Leafgreen"_s},
    {145, "Leafgreen Metal"_s},
    {146, "Leafgreen Gloss"_s},
    {147, "Military Green"_s},
    {148, "Military Green Metal"_s},
    {149, "Military Green Gloss"_s},
    {150, "Green"_s},
    {151, "Green Metal"_s},
    {152, "Green Gloss"_s},
    {153, "Dark Green"_s},
    {154, "Dark Green Metal"_s},
    {155, "Dark Green Gloss"_s},
    {156, "Teal"_s},
    {157, "Teal Metal"_s},
    {158, "Teal Gloss"_s},
    {159, "Cyan"_s},
    {160, "Cyan Metal"_s},
    {161, "Cyan Gloss"_s},
    {162, "Blue"_s},
    {163, "Blue Metal"_s},
    {164, "Blue Gloss"_s},
    {165, "Blue Sky"_s},
    {166, "Blue Sky Metal"_s},
    {167, "Blue Sky Gloss"_s},
    {168, "Dark Blue"_s},
    {169, "Dark Blue Metal"_s},
    {170, "Dark Blue Gloss"_s},
    {171, "Purple"_s},
    {172, "Purple Metal"_s},
    {173, "Purple Gloss"_s},
    {174, "Dark Purple"_s},
    {175, "Dark Purple Metal"_s},
    {176, "Dark Purple Gloss"_s},
    {177, "Pink"_s},
    {178, "Pink Metal"_s},
    {179, "Pink Gloss"_s},
    {180, "Rosy Brown"_s},
    {181, "Rosy Brown Metal"_s},
    {182, "Rosy Brown Gloss"_s},
    {183, "Ivory"_s},
    {184, "Ivory Metal"_s},
    {185, "Ivory Gloss"_s},
    {186, "Slate Brown"_s},
    {187, "Slate Brown Metal"_s},
    {188, "Slate Brown Gloss"_s},
    {189, "Slate Green"_s},
    {190, "Slate Green Metal"_s},
    {191, "Slate Green Gloss"_s},
    {192, "Slate Blue"_s},
    {193, "Slate Blue Metal"_s},
    {194, "Slate Blue Gloss"_s},
    {195, "Slate Purple"_s},
    {196, "Slate Purple Metal"_s},
    {197, "Slate Purple Gloss"_s},
    {198, "White Glow"_s},
    {199, "White Radiance"_s},
    {200, "Red Glow"_s},
    {201, "Red Radiance"_s},
    {202, "Orange Glow"_s},
    {203, "Orange Radiance"_s},
    {204, "Yellow Glow"_s},
    {205, "Yellow Radiance"_s},
    {206, "Leafgreen Glow"_s},
    {207, "Leafgreen Radiance"_s},
    {208, "Green Glow"_s},
    {209, "Green Radiance"_s},
    {210, "Teal Glow"_s},
    {211, "Teal Radiance"_s},
    {212, "Cyan Glow"_s},
    {213, "Cyan Radiance"_s},
    {214, "Blue Glow"_s},
    {215, "Blue Radiance"_s},
    {216, "Purple Glow"_s},
    {217, "Purple Radiance"_s},
    {218, "Pink Glow"_s},
    {219, "Pink Radiance"_s},
    {220, "Grey Camo"_s},
    {221, "Dark Grey Camo"_s},
    {222, "Green Camo"_s},
    {223, "Dark Green Camo"_s},
    {224, "Brown Camo"_s},
    {225, "Dark Brown Camo"_s},
    {226, "Blue Camo"_s},
    {227, "Dark Blue Camo"_s},
}
#endif
;
