#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Corrade/Containers/String.h>

#include <Magnum/Magnum.h>
#include <Magnum/Math/Vector3.h>

using namespace Corrade;
using namespace Magnum;

enum class BulletLauncherAttachmentStyle {
    #define c(enumerator, enumstr) enumerator,
    #include "../Maps/BulletLauncherAttachmentStyles.hpp"
    #undef c
};

enum class BulletLauncherSocket {
    #define c(enumerator, enumstr, name) enumerator,
    #include "../Maps/BulletLauncherSockets.hpp"
    #undef c
};

struct BulletLauncherAttachment {
    BulletLauncherSocket socket = BulletLauncherSocket::Auto;
    Vector3 relativeLocation;
    Vector3 offsetLocation;
    Vector3 relativeRotation;
    Vector3 offsetRotation;
    Vector3 relativeScale;
};
