// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include "Weapon.h"

Weapon::Weapon(const Weapon& other) {
    name = other.name;
    type = other.type;
    parts = Containers::Array<WeaponPart>{other.parts.size()};
    for(UnsignedInt i = 0; i < parts.size(); i++) {
        parts[i] = other.parts[i];
    }
    customStyles = other.customStyles;
    attached = other.attached;
    damageType = other.damageType;
    dualWield = other.dualWield;
    effectColourMode = other.effectColourMode;
    effectColour = other.effectColour;
}

Weapon& Weapon::operator=(const Weapon& other) {
    name = other.name;
    type = other.type;
    parts = Containers::Array<WeaponPart>{other.parts.size()};
    for(UnsignedInt i = 0; i < parts.size(); i++) {
        parts[i] = other.parts[i];
    }
    customStyles = other.customStyles;
    attached = other.attached;
    damageType = other.damageType;
    dualWield = other.dualWield;
    effectColourMode = other.effectColourMode;
    effectColour = other.effectColour;

    return *this;
}
