#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Magnum/Types.h>

using namespace Magnum;

enum MaterialID : Int {
    VerseSteel   = 0xC3500,
    Undinium     = 0xC3501,
    NecriumAlloy = 0xC3502,
    Lunarite     = 0xC3503,
    Asterite     = 0xC3504,

    Ednil        = 0xC350A,
    Nuflalt      = 0xC350B,
    Aurelene     = 0xC350C,
    Soldus       = 0xC350D,
    SynthesisedN = 0xC350E,

    Alcarbonite = 0xC3514,
    Keriphene   = 0xC3515,
    NitinolCM   = 0xC3516,
    Quarkium    = 0xC3517,
    Alterene    = 0xC3518,

    MixedComposition      = 0xDBBA0,
    VoidResidue           = 0xDBBA1,
    MuscularConstruction  = 0xDBBA2,
    MineralExoskeletology = 0xDBBA3,
    CarbonisedSkin        = 0xDBBA4
};
