#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Corrade/Containers/Pointer.h>
#include <Corrade/Containers/StringView.h>

#include "StructProperty.h"

using namespace Corrade;

struct ColourStructProperty : public StructProperty {
    using ptr = Containers::Pointer<ColourStructProperty>;
    ColourStructProperty() {
        using namespace Containers::Literals;
        structType = "LinearColor"_s;
    }
    Float r = 0.0f, g = 0.0f, b = 0.0f, a = 0.0f;
};
