#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Corrade/Containers/Pointer.h>
#include <Corrade/Containers/String.h>
#include <Corrade/Containers/StringView.h>

#include "UnrealPropertyBase.h"

using namespace Corrade;

struct MapProperty : public UnrealPropertyBase {
    using ptr = Containers::Pointer<MapProperty>;

    MapProperty() {
        using namespace Containers::Literals;
        propertyType = "MapProperty"_s;
    }

    Containers::String keyType;
    Containers::String valueType;

    struct KeyValuePair {
        UnrealPropertyBase::ptr key;
        Containers::Array<UnrealPropertyBase::ptr> values;
    };

    Containers::Array<KeyValuePair> map;
};
