#pragma once

// MassBuilderSaveTool
// Copyright (C) 2021-2022 Guillaume Jacquemin
//
// This program is free software: you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation, either version 3 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program.  If not, see <https://www.gnu.org/licenses/>.

#include <Corrade/Containers/Pointer.h>
#include <Corrade/Containers/StringView.h>

#include <Magnum/Types.h>

#include "StructProperty.h"

using namespace Corrade;
using namespace Magnum;

struct Vector2DStructProperty : public StructProperty {
    using ptr = Containers::Pointer<Vector2DStructProperty>;

    Vector2DStructProperty() {
        using namespace Containers::Literals;
        structType = "Vector2D"_s;
    }

    Float x = 0.0f, y = 0.0f;
};
